class HRuleBreakpoint(gdb.Breakpoint):
	def stop(self):
		frame = gdb.selected_frame()
		block = frame.block()

		for p in block:
			top_level_parse.parser_objs[int(p.value(frame))] = Parser(p.name, int(p.value(frame)))

class BreakpointManager():
	def __init__(self):
		self.hammer_retq_breakpoints = []
		self.h_rule_breakpoints = []

		self.h_do_parse = None
		self.h_packrat_parse = None
		self.perform_lowlevel_parse = None
		self.h_arena_malloc_raw = None

		self.parse_action = None
		self.parse_choice = None
		self.parse_sequence = None
		self.parse_difference = None
		self.parse_many = None
		self.parse_and = None
		self.parse_attr_bool = None
		self.parse_bind = None
		self.parse_bits = None
		self.parse_butnot = None
		self.parse_charset = None
		self.parse_ch = None
		self.parse_end = None
		self.parse_endianness = None
		self.parse_epsilon = None
		self.parse_ignore = None
		self.parse_ignoreseq = None
		self.parse_indirect = None
		self.parse_int_range = None
		self.parse_not = None
		self.parse_nothing = None
		self.parse_optional = None
		self.parse_permutation = None
		self.parse_skip = None
		self.parse_seek = None
		self.parse_tell = None
		self.parse_token = None
		self.parse_unimplemented = None
		self.parse_put = None
		self.parse_get = None
		self.parse_whitespace = None
		self.parse_xor = None

	def set_h_rule_breakpoints(self):
		for func in H_RULE_FUNCTIONS:
		func_retq = locate_retq(func[0], func[1])
		self.h_rule_breakpoints[func] = HRuleBreakpoint("*" + hex(func_retq))
